//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainUnit.h"
#include "UnitEdit.h"
#include "HexDumpUnit.h"
#include "AboutBoxUnit.h"
#include "Constant.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner) ,mSaveDataMaxSize(18368)
{
    // f[^GÅm
    mSaveData = new char[mSaveDataMaxSize];
    mSaveDataReady = false;

    // tB[hXg̐ݒ
    mFieldList = new TList();
    InitFieldList();
    // ʃvtB[hXg̐ݒ
    mSpecialPlanList = new TList();
    InitSpecialPlanList();

    // JvXg̊m
    mPlanNameList = new TStringList;
    // @̖Xg̊m
    mUnitNameList = new TStringList;
    // pCbgXg̊m
    mPilotNameList =new TStringList;
    // GAXg̊m
    mAreaNameList =new TStringList;
    // KXg̊m
    mClassList =new TStringList;
    // ʃvXg̊m
    mSpecialPlan = new TStringList;

    AnsiString thePath = ExtractFileDir(Application->ExeName);
    try {
        // Jvt@Cǂݍ
        mPlanNameList->LoadFromFile(thePath + "\\plan.txt");
        // t@Cǂݍ
        mUnitNameList->LoadFromFile(thePath + "\\unit.txt");
        // pCbgt@Cǂݍ
        mPilotNameList->LoadFromFile(thePath + "\\pilot.txt");
        // GAt@Cǂݍ
        mAreaNameList->LoadFromFile(thePath + "\\area.txt");
        // Kt@Cǂݍ
        mClassList->LoadFromFile(thePath + "\\class.txt");
        // ʃvt@Cǂݍ
        mSpecialPlan->LoadFromFile(thePath + "\\special.txt");

        // Jv\̐ݒ
        InitPlan();
        // \̐ݒ
        InitUnit();
        // pCbg\̐ݒ
        InitPilot();
        // GA\̐ݒ
        InitArea();
        // ʃGA\̐ݒ
        InitSpecialArea();
        // ʃv\̐ݒ
        InitSpecialPlan();
        // ꗗ\̐ݒ
        InitWeapon();
    }
    catch(...) {
        ShowMessage("t@CǍG[");
        Application->Terminate();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
    // tB[hXg̔p
    for (int i = 0; i < mFieldList->Count; i++) {
        delete mFieldList->Items[i];
    }
    delete mFieldList;
    // ʃvtB[hXg̔p
    for (int i = 0; i < mFieldList->Count; i++) {
        delete mSpecialPlanList->Items[i];
    }
    delete mSpecialPlanList;

    // JvXg̔p
    delete mPlanNameList;
    // @̖Xg̔p
    delete mUnitNameList;
    // pCbgXg̔p
    delete mPilotNameList;
    // GAXg̔p
    delete mAreaNameList;
    // KXg̊m
    delete mClassList;
    // ʃvXg̔p
    delete mSpecialPlan;

    // f[^GA̔p
    delete[] mSaveData;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileOpenMenuClick(TObject *Sender)
{
    if (OpenDialog->Execute()) {
        // Z[uf[^t@CJ
        TFileStream *theFileStream;
        try {
            theFileStream = new TFileStream(OpenDialog->FileName, fmOpenRead, fmShareDenyWrite);
            if (theFileStream->Size > mSaveDataMaxSize) {
                throw;
            }
        } catch (...) {
            ShowMessage("t@CǍG[\n" + OpenDialog->FileName);
            return;
        }

        // t@Cǂݍ
        mSaveDataPath = OpenDialog->FileName;
        mSaveDataSize = theFileStream->Size;
        theFileStream->Read(mSaveData, theFileStream->Size);

        // tB[hǂݏo
        SaveDataRead();

        mSaveDataReady = true;
        // j[ڂ̍XV
        FileSaveMenu->Enabled = true;
        ViewUnitEditMenu->Enabled = true;
        ViewDumpManu->Enabled = true;
        // EBhE^Cg̐ݒ
        AnsiString theFileName = ExtractFileName(OpenDialog->FileName);
        MainForm->Caption = "M̖] " + theFileName;

        // Z[uf[^t@C
        delete theFileStream;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileSaveMenuClick(TObject *Sender)
{
    // tB[h
    SaveDataWrite();
    // Z[uf[^t@CJ
    TFileStream *theFileStream;
    try {
        theFileStream = new TFileStream(mSaveDataPath, fmCreate, fmShareExclusive);
    } catch (...) {
        ShowMessage("t@CG[\n" + mSaveDataPath);
        return;
    }
    // t@Cɏ
    theFileStream->Write(mSaveData, mSaveDataSize);

    // PUi_v\
    //ShowHexDump();

    // Z[uf[^t@C
    delete theFileStream;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileExitMenuClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ViewUnitEditMenuClick(TObject *Sender)
{
    // GfB^
    UnitEditForm->Show();

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ViewDumpManuClick(TObject *Sender)
{
    // PUi_v̕\
    if (HexDumpForm->Visible) {
        HexDumpForm->Close();
    } else {
        ShowHexDump();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HelpAboutMenuClick(TObject *Sender)
{
    // o[W_CAO̕\
    AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitFieldList()
{
    // tB[hXg̐ݒ
    // R
    mFieldList->Add(new TField(ComboBox1_1,   0x0644,  0,  4));   // ͖
    mFieldList->Add(new TField(Edit1_1,       0x0656,  0, 24));   // 
    mFieldList->Add(new TField(Edit1_2,       0x0659,  0, 24));   // 
    mFieldList->Add(new TField(Edit1_3,       0x064D,  0,  7));   // 񕔔\
    mFieldList->Add(new TField(CheckBox1_1,   0x05FA,  1,  1));   // 񕔎ς
    mFieldList->Add(new TField(Edit1_4,       0x0644,  4,  5));   // bLv
    mFieldList->Add(new TField(Edit1_5,       0x0644,  9,  5));   // lrLv
    mFieldList->Add(new TField(Edit1_6,       0x0644, 14,  5));   // l`Lv
    mFieldList->Add(new TField(Edit1_7,       0x0644, 19,  5));   // GLv
    mFieldList->Add(new TField(Edit1_8,       0x0647,  0,  7));   // bOt
    mFieldList->Add(new TField(Edit1_9,       0x0647,  7,  7));   // lrOt
    mFieldList->Add(new TField(Edit1_10,      0x0648,  6,  7));   // l`Ot
    mFieldList->Add(new TField(Edit1_11,      0x0649,  5,  7));   // GOt
    mFieldList->Add(new TField(CheckBox1_2,   0x05FA,  4,  1));   // bς
    mFieldList->Add(new TField(CheckBox1_3,   0x05FA,  3,  1));   // lrς
    mFieldList->Add(new TField(CheckBox1_4,   0x05FA,  2,  1));   // l`ς
    mFieldList->Add(new TField(Edit1_12,      0x064F,  5,  7));   // TChUOt
    mFieldList->Add(new TField(Edit1_13,      0x0650,  4,  7));   // ssQOt
    mFieldList->Add(new TField(Edit1_14,      0x0651,  3,  7));   // ؐDcOt
    mFieldList->Add(new TField(Edit1_15,      0x0652,  2,  7));   // RYƃOt
    mFieldList->Add(new TField(Edit1_16,      0x0653,  1,  7));   // GERYƃOt
    mFieldList->Add(new TField(Edit1_17,      0x064D,  7,  7));   // G͂POt
    mFieldList->Add(new TField(Edit1_18,      0x064E,  6,  7));   // G͂QOt
    mFieldList->Add(new TField(CheckBox1_5,   0x0643,  4,  1));   // G͂Pς
    mFieldList->Add(new TField(CheckBox1_6,   0x0643,  3,  1));   // G͂Qς
    mFieldList->Add(new TField(CheckBox1_7,   0x0643,  2,  1));   // TChUς
    mFieldList->Add(new TField(CheckBox1_8,   0x0643,  1,  1));   // ssQς
    mFieldList->Add(new TField(CheckBox1_9,   0x0643,  0,  1));   // ؐDcς
    mFieldList->Add(new TField(CheckBox1_10,  0x0642,  7,  1));   // RYƍς
    mFieldList->Add(new TField(CheckBox1_11,  0x0642,  6,  1));   // GERYƍς
    mFieldList->Add(new TField(StringGrid1_1, 0x438F,  6,  9));   // Jv
    mFieldList->Add(new TField(StringGrid1_2, 0x068C,  0,175));   // 
    // G͂P
    mFieldList->Add(new TField(ComboBox2_1,   0x065C,  0,  4));   // ͖
    mFieldList->Add(new TField(Edit2_1,       0x066E,  0, 24));   // 
    mFieldList->Add(new TField(Edit2_2,       0x0671,  0, 24));   // 
    mFieldList->Add(new TField(Edit2_3,       0x0665,  0,  7));   // 񕔔\
    mFieldList->Add(new TField(Edit2_4,       0x065C,  4,  5));   // bLv
    mFieldList->Add(new TField(Edit2_5,       0x065C,  9,  5));   // lrLv
    mFieldList->Add(new TField(Edit2_6,       0x065C, 14,  5));   // l`Lv
    mFieldList->Add(new TField(Edit2_7,       0x065C, 19,  5));   // GLv
    mFieldList->Add(new TField(Edit2_8,       0x065F,  0,  7));   // bOt
    mFieldList->Add(new TField(Edit2_9,       0x065F,  7,  7));   // lrOt
    mFieldList->Add(new TField(Edit2_10,      0x0660,  6,  7));   // l`Ot
    mFieldList->Add(new TField(Edit2_11,      0x0661,  5,  7));   // GOt
    mFieldList->Add(new TField(Edit2_12,      0x0667,  5,  7));   // TChUOt
    mFieldList->Add(new TField(Edit2_13,      0x0668,  4,  7));   // ssQOt
    mFieldList->Add(new TField(Edit2_14,      0x0669,  3,  7));   // ؐDcOt
    mFieldList->Add(new TField(Edit2_15,      0x066A,  2,  7));   // RYƃOt
    mFieldList->Add(new TField(Edit2_16,      0x066B,  1,  7));   // GERYƃOt
    mFieldList->Add(new TField(StringGrid2_1, 0x44B9,  7,  9));   // Jv
    mFieldList->Add(new TField(StringGrid2_2, 0x17a3,  0,175));   // 
    // G͂Q
    mFieldList->Add(new TField(ComboBox3_1,   0x0674,  0,  4));   // ͖
    mFieldList->Add(new TField(Edit3_1,       0x0686,  0, 24));   // 
    mFieldList->Add(new TField(Edit3_2,       0x0689,  0, 24));   // 
    mFieldList->Add(new TField(Edit3_3,       0x067D,  0,  7));   // 񕔔\
    mFieldList->Add(new TField(Edit3_4,       0x0674,  4,  5));   // bLv
    mFieldList->Add(new TField(Edit3_5,       0x0674,  9,  5));   // lrLv
    mFieldList->Add(new TField(Edit3_6,       0x0674, 14,  5));   // l`Lv
    mFieldList->Add(new TField(Edit3_7,       0x0674, 19,  5));   // GLv
    mFieldList->Add(new TField(Edit3_8,       0x0677,  0,  7));   // bOt
    mFieldList->Add(new TField(Edit3_9,       0x0677,  7,  7));   // lrOt
    mFieldList->Add(new TField(Edit3_10,      0x0678,  6,  7));   // l`Ot
    mFieldList->Add(new TField(Edit3_11,      0x0679,  5,  7));   // GOt
    mFieldList->Add(new TField(Edit3_12,      0x067F,  5,  7));   // TChUOt
    mFieldList->Add(new TField(Edit3_13,      0x0680,  4,  7));   // ssQOt
    mFieldList->Add(new TField(Edit3_14,      0x0681,  3,  7));   // ؐDcOt
    mFieldList->Add(new TField(Edit3_15,      0x0682,  2,  7));   // RYƃOt
    mFieldList->Add(new TField(Edit3_16,      0x0683,  1,  7));   // GERYƃOt
    mFieldList->Add(new TField(StringGrid3_1, 0x45E4,  0,  9));   // Jv
    mFieldList->Add(new TField(StringGrid3_2, 0x28BA,  0,175));   // 
    // pCbg
    mFieldList->Add(new TField(StringGrid4_1, 0x39D1,  0, 52));   // pCbg
    // GA
    mFieldList->Add(new TField(StringGrid5_1, 0x4160,  4,112));   // ʃGA
    mFieldList->Add(new TField(StringGrid5_2, 0x426A,  4, 23));   // GA
    // 
    mFieldList->Add(new TField(ComboBox6_1,   0x01B4,  4,  7));   // P^Q
    mFieldList->Add(new TField(Edit6_1,       0x01B4,  4,  7));   // ^[
    mFieldList->Add(new TField(CheckBox6_1,   0x05C6,  3,  1));   // TChVL
    mFieldList->Add(new TField(CheckBox6_2,   0x05C6,  4,  1));   // ANVYL
    mFieldList->Add(new TField(CheckBox6_3,   0x05C6,  5,  1));   // OvXQL
    mFieldList->Add(new TField(CheckBox6_4,   0x05C6,  6,  1));   // rA[YL
    mFieldList->Add(new TField(CheckBox6_5,   0x05C6,  7,  1));   // Com\mL
    mFieldList->Add(new TField(CheckBox6_10,  0x05C7,  0,  1));   // LtHjANU\
    mFieldList->Add(new TField(CheckBox6_11,  0x05C7,  1,  1));   // j[[NNU\
    mFieldList->Add(new TField(CheckBox6_12,  0x05C7,  2,  1));   // Wu[NU\
    mFieldList->Add(new TField(CheckBox6_13,  0x05C7,  3,  1));   // nCNU\
    mFieldList->Add(new TField(CheckBox6_14,  0x05C7,  4,  1));   // ggNU\
    mFieldList->Add(new TField(CheckBox6_15,  0x05C7,  5,  1));   // yLNU\
    mFieldList->Add(new TField(CheckBox6_16,  0x05C7,  6,  1));   // }hXNU\
    mFieldList->Add(new TField(CheckBox6_17,  0x05C7,  7,  1));   // IfbTNU\
    mFieldList->Add(new TField(CheckBox6_18,  0x05C8,  0,  1));   // xt@XgNU\
    mFieldList->Add(new TField(CheckBox6_19,  0x05C8,  1,  1));   // L}WNU\
    mFieldList->Add(new TField(CheckBox6_20,  0x05C8,  2,  1));   // ic[NU\
    mFieldList->Add(new TField(CheckBox6_21,  0x05C8,  3,  1));   // \NU\
    mFieldList->Add(new TField(CheckBox6_22,  0x05C8,  4,  1));   // AEoIAEN[NU\
    mFieldList->Add(new TField(CheckBox6_23,  0x05C8,  5,  1));   // Oi_NU\
    mFieldList->Add(new TField(CheckBox6_24,  0x05C8,  6,  1));   // TChRNU\
    mFieldList->Add(new TField(CheckBox6_25,  0x05C8,  7,  1));   // ANVYNU\
    mFieldList->Add(new TField(CheckBox6_26,  0x05C9,  0,  1));   // OvXQNU\
    mFieldList->Add(new TField(CheckBox6_27,  0x05C9,  1,  1));   // rA[YNU\
    mFieldList->Add(new TField(CheckBox6_28,  0x05C9,  2,  1));   // Com\mNU\
    mFieldList->Add(new TField(CheckListBox6_1, 0x0585,  0,  0));   // ʃv
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitSpecialPlanList()
{
    // ʃvtB[hXg̐ݒ
	// WI
    mSpecialPlanList->Add(new TCellField(  1, 0, 0x0585, 8, 1));	// ꎟ~āiWIj
    mSpecialPlanList->Add(new TCellField(  2, 0, 0x0585, 7, 1));	// ꎟ~siWIj
    mSpecialPlanList->Add(new TCellField(  3, 0, 0x0585, 5, 1));	// 񎟍~āiWIj
    mSpecialPlanList->Add(new TCellField(  4, 0, 0x0585, 4, 1));	// 񎟍~siWIj
    mSpecialPlanList->Add(new TCellField(  5, 0, 0x0585, 2, 1));	// O~āiWIj
    mSpecialPlanList->Add(new TCellField(  6, 0, 0x0585, 1, 1));	// O~siWIj
    mSpecialPlanList->Add(new TCellField(  7, 0, 0x0586, 7, 1));	// }hXUāiWIj
    mSpecialPlanList->Add(new TCellField(  8, 0, 0x0586, 6, 1));	// }hXUsiWIj
    mSpecialPlanList->Add(new TCellField(  9, 0, 0x0586, 4, 1));	// nCUāiWIj
    mSpecialPlanList->Add(new TCellField( 10, 0, 0x0586, 3, 1));	// nCUsiWIj
    mSpecialPlanList->Add(new TCellField( 11, 0, 0x0586, 1, 1));	// ggUāiWIj
    mSpecialPlanList->Add(new TCellField( 12, 0, 0x0587, 8, 1));	// ggUsiWIj
    mSpecialPlanList->Add(new TCellField( 13, 0, 0x0587, 6, 1));	// kUāiWIj
    mSpecialPlanList->Add(new TCellField( 14, 0, 0x0587, 5, 1));	// kUsiWIj
    mSpecialPlanList->Add(new TCellField( 15, 0, 0x0587, 3, 1));	// K}̍āiWIj
    mSpecialPlanList->Add(new TCellField( 16, 0, 0x0587, 2, 1));	// K}̍siWIj
    mSpecialPlanList->Add(new TCellField( 17, 0, 0x0588, 8, 1));	// xt@XgUāiWIj
    mSpecialPlanList->Add(new TCellField( 18, 0, 0x0588, 7, 1));	// xt@XgUsiWIj
    mSpecialPlanList->Add(new TCellField( 19, 0, 0x0588, 5, 1));	// Wu[UāiWIj
    mSpecialPlanList->Add(new TCellField( 20, 0, 0x0588, 4, 1));	// Wu[UsiWIj
    mSpecialPlanList->Add(new TCellField( 21, 0, 0x0589, 8, 1));	// i2UāiWIj
    mSpecialPlanList->Add(new TCellField( 22, 0, 0x0589, 7, 1));	// i2UsiWIj
    mSpecialPlanList->Add(new TCellField( 23, 0, 0x0589, 5, 1));	// 񎟃ueBbVāiWIj
    mSpecialPlanList->Add(new TCellField( 24, 0, 0x0589, 4, 1));	// 񎟃ueBbVsiWIj
    mSpecialPlanList->Add(new TCellField( 25, 0, 0x0589, 2, 1));	// Wu[~āiWIj
    mSpecialPlanList->Add(new TCellField( 26, 0, 0x0589, 1, 1));	// Wu[~siWIj
    mSpecialPlanList->Add(new TCellField( 27, 0, 0x058A, 7, 1));	// DlސāiWIj
    mSpecialPlanList->Add(new TCellField( 28, 0, 0x058A, 6, 1));	// DlސsiWIj
    mSpecialPlanList->Add(new TCellField( 29, 0, 0x058A, 4, 1));	// rRvāiWIj
    mSpecialPlanList->Add(new TCellField( 30, 0, 0x058A, 3, 1));	// rRvsiWIj
    mSpecialPlanList->Add(new TCellField( 31, 0, 0x058A, 1, 1));	// tiK@֐ݗāiWIj
    mSpecialPlanList->Add(new TCellField( 32, 0, 0x058B, 8, 1));	// tiK@֐ݗsiWIj
    mSpecialPlanList->Add(new TCellField( 33, 0, 0x058B, 6, 1));	// EXAMāiWIj
    mSpecialPlanList->Add(new TCellField( 34, 0, 0x058B, 5, 1));	// EXAMsiWIj
    mSpecialPlanList->Add(new TCellField( 35, 0, 0x058B, 3, 1));	// \[CJvāiWIj
    mSpecialPlanList->Add(new TCellField( 36, 0, 0x058B, 2, 1));	// \[CJvsiWIj
    mSpecialPlanList->Add(new TCellField( 37, 0, 0x058C, 8, 1));	// AvTXJvāiWIj
    mSpecialPlanList->Add(new TCellField( 38, 0, 0x058C, 7, 1));	// AvTXJvsiWIj
    mSpecialPlanList->Add(new TCellField( 39, 0, 0x058C, 5, 1));	// AX^XJāiWIj
    mSpecialPlanList->Add(new TCellField( 40, 0, 0x058C, 4, 1));	// AX^XJsiWIj
    mSpecialPlanList->Add(new TCellField( 41, 0, 0x058D, 8, 1));	// Wu[UpMSJāiWIj
    mSpecialPlanList->Add(new TCellField( 42, 0, 0x058D, 7, 1));	// Wu[UpMSJsiWIj
    mSpecialPlanList->Add(new TCellField( 43, 0, 0x058D, 5, 1));	// Wu[āiWIj
    mSpecialPlanList->Add(new TCellField( 44, 0, 0x058D, 4, 1));	// Wu[siWIj
    mSpecialPlanList->Add(new TCellField( 45, 0, 0x058D, 2, 1));	// yYvāiWIj
    mSpecialPlanList->Add(new TCellField( 46, 0, 0x058D, 1, 1));	// yYvsiWIj
    mSpecialPlanList->Add(new TCellField( 47, 0, 0x058E, 7, 1));	// vāiWIj
    mSpecialPlanList->Add(new TCellField( 48, 0, 0x058E, 6, 1));	// vsiWIj
    mSpecialPlanList->Add(new TCellField( 49, 0, 0x058E, 4, 1));	// QOOʎYvāiWIj
    mSpecialPlanList->Add(new TCellField( 50, 0, 0x058E, 3, 1));	// QOOʎYvsiWIj
    mSpecialPlanList->Add(new TCellField( 51, 0, 0x058F, 7, 1));	// QOOʎYtOHiWIj
    mSpecialPlanList->Add(new TCellField( 52, 0, 0x058E, 2, 1));	// MʎYvsiWIj
    mSpecialPlanList->Add(new TCellField( 53, 0, 0x058E, 1, 1));	// MʎYvāiWIj
    mSpecialPlanList->Add(new TCellField( 54, 0, 0x058F, 8, 1));	// MʎYtOHiWIj
    mSpecialPlanList->Add(new TCellField( 55, 0, 0x058F, 6, 1));	// \iWIj
    mSpecialPlanList->Add(new TCellField( 56, 0, 0x058F, 5, 1));	// siWIj
    mSpecialPlanList->Add(new TCellField( 57, 0, 0x058F, 3, 1));	// V^K_DvāiWIj
    mSpecialPlanList->Add(new TCellField( 58, 0, 0x058F, 2, 1));	// V^K_DvsiWIj
    mSpecialPlanList->Add(new TCellField( 59, 0, 0x0590, 8, 1));	// ̋āiWIj
    mSpecialPlanList->Add(new TCellField( 60, 0, 0x0590, 7, 1));	// ̋siWIj
    mSpecialPlanList->Add(new TCellField( 61, 0, 0x0590, 5, 1));	// eB^[YxvāiWIj
    mSpecialPlanList->Add(new TCellField( 62, 0, 0x0590, 4, 1));	// eB^[YxvsiWIj
    mSpecialPlanList->Add(new TCellField( 63, 0, 0x0591, 6, 1));	// eB^[YxtOHiWIj
    mSpecialPlanList->Add(new TCellField( 64, 0, 0x0591, 8, 1));	// GD[SxvāiWIj
    mSpecialPlanList->Add(new TCellField( 65, 0, 0x0591, 7, 1));	// GD[SxvsiWIj
    mSpecialPlanList->Add(new TCellField( 66, 0, 0x0590, 3, 1));	// GD[SxtOHiWIj
    mSpecialPlanList->Add(new TCellField( 67, 0, 0x0591, 5, 1));	// NTJvāiWIj
    mSpecialPlanList->Add(new TCellField( 68, 0, 0x0591, 4, 1));	// NTJvsiWIj
    mSpecialPlanList->Add(new TCellField( 69, 0, 0x0591, 2, 1));	// Wu[āiWIj
    mSpecialPlanList->Add(new TCellField( 70, 0, 0x0591, 1, 1));	// Wu[siWIj
    mSpecialPlanList->Add(new TCellField( 71, 0, 0x0592, 7, 1));	// OvX2[΃W~gt]iWIj
    mSpecialPlanList->Add(new TCellField( 72, 0, 0x0592, 6, 1));	// OvX2s[΃W~gt]iWIj
    mSpecialPlanList->Add(new TCellField( 73, 0, 0x0592, 4, 1));	// OvX2[΃VbR]iWIj
    mSpecialPlanList->Add(new TCellField( 74, 0, 0x0592, 3, 1));	// OvX2s[΃VbR]iWIj
    mSpecialPlanList->Add(new TCellField( 75, 0, 0x0592, 1, 1));	// Oi_[΃lIWI]iWIj
    mSpecialPlanList->Add(new TCellField( 76, 0, 0x0593, 8, 1));	// Oi_s[΃lIWI]iWIj
    mSpecialPlanList->Add(new TCellField( 77, 0, 0x0593, 6, 1));	// Oi_[ΐWI]iWIj
    mSpecialPlanList->Add(new TCellField( 78, 0, 0x0593, 5, 1));	// Oi_s[ΐWI]iWIj
    mSpecialPlanList->Add(new TCellField( 79, 0, 0x0593, 3, 1));	// j[[NāiWIj
    mSpecialPlanList->Add(new TCellField( 80, 0, 0x0593, 2, 1));	// j[[NsiWIj
    mSpecialPlanList->Add(new TCellField( 81, 0, 0x0594, 8, 1));	// rA[YāiWIj
    mSpecialPlanList->Add(new TCellField( 82, 0, 0x0594, 7, 1));	// rA[YsiWIj
    mSpecialPlanList->Add(new TCellField( 83, 0, 0x0594, 5, 1));	// ANVYāiWIj
    mSpecialPlanList->Add(new TCellField( 84, 0, 0x0594, 4, 1));	// ANVYsiWIj
	// nAMR
    mSpecialPlanList->Add(new TCellField( 86, 0, 0x0596, 4, 1));	// VāiAMj
    mSpecialPlanList->Add(new TCellField( 87, 0, 0x0596, 3, 1));	// VsiAMj
    mSpecialPlanList->Add(new TCellField( 88, 0, 0x0596, 1, 1));	// r\vāiAMj
    mSpecialPlanList->Add(new TCellField( 89, 0, 0x0597, 8, 1));	// r\vsiAMj
    mSpecialPlanList->Add(new TCellField( 90, 0, 0x0597, 6, 1));	// RXV[YvāiAMj
    mSpecialPlanList->Add(new TCellField( 91, 0, 0x0597, 5, 1));	// RXV[YvsiAMj
    mSpecialPlanList->Add(new TCellField( 92, 0, 0x0597, 3, 1));	// GMvāiAMj
    mSpecialPlanList->Add(new TCellField( 93, 0, 0x0597, 2, 1));	// GMvsiAMj
    mSpecialPlanList->Add(new TCellField( 94, 0, 0x0598, 8, 1));	// IfbTāiAMj
    mSpecialPlanList->Add(new TCellField( 95, 0, 0x0598, 7, 1));	// IfbTsiAMj
    mSpecialPlanList->Add(new TCellField( 96, 0, 0x0598, 5, 1));	// \[VXeJvāiAMj
    mSpecialPlanList->Add(new TCellField( 97, 0, 0x0598, 4, 1));	// \[VXeJvsiAMj
    mSpecialPlanList->Add(new TCellField( 98, 0, 0x0599, 8, 1));	// ꍆāiAMj
    mSpecialPlanList->Add(new TCellField( 99, 0, 0x0599, 7, 1));	// ꍆsiAMj
    mSpecialPlanList->Add(new TCellField(100, 0, 0x0599, 5, 1));	// AEoIAEN[UāiAMj
    mSpecialPlanList->Add(new TCellField(101, 0, 0x0599, 4, 1));	// AEoIAEN[UsiAMj
    mSpecialPlanList->Add(new TCellField(102, 0, 0x0599, 2, 1));	// NT@֐ݗāiAMj
    mSpecialPlanList->Add(new TCellField(103, 0, 0x0599, 1, 1));	// NT@֐ݗsiAMj
    mSpecialPlanList->Add(new TCellField(104, 0, 0x059A, 7, 1));	// MCZpāiAMj
    mSpecialPlanList->Add(new TCellField(105, 0, 0x059A, 6, 1));	// MCZpsiAMj
    mSpecialPlanList->Add(new TCellField(106, 0, 0x059A, 4, 1));	// EXAMāiAMj
    mSpecialPlanList->Add(new TCellField(107, 0, 0x059A, 3, 1));	// EXAMsiAMj
    mSpecialPlanList->Add(new TCellField(108, 0, 0x059A, 1, 1));	// ՎvāiAMj
    mSpecialPlanList->Add(new TCellField(109, 0, 0x059B, 8, 1));	// ՎvsiAMj
    mSpecialPlanList->Add(new TCellField(110, 0, 0x059B, 6, 1));	// kUāiAMj
    mSpecialPlanList->Add(new TCellField(111, 0, 0x059B, 5, 1));	// kUsiAMj
    mSpecialPlanList->Add(new TCellField(112, 0, 0x059B, 3, 1));	// nCUāiAMj
    mSpecialPlanList->Add(new TCellField(113, 0, 0x059B, 2, 1));	// nCUsiAMj
    mSpecialPlanList->Add(new TCellField(114, 0, 0x059C, 8, 1));	// LtHjAUāiAMj
    mSpecialPlanList->Add(new TCellField(115, 0, 0x059C, 7, 1));	// LtHjAUsiAMj
    mSpecialPlanList->Add(new TCellField(116, 0, 0x059C, 5, 1));	// j[[NUāiAMj
    mSpecialPlanList->Add(new TCellField(117, 0, 0x059C, 4, 1));	// j[[NUsiAMj
    mSpecialPlanList->Add(new TCellField(118, 0, 0x059D, 8, 1));	// L}WUāiAMj
    mSpecialPlanList->Add(new TCellField(119, 0, 0x059D, 7, 1));	// L}WUsiAMj
    mSpecialPlanList->Add(new TCellField(120, 0, 0x059D, 5, 1));	// Oi_UāiAMj
    mSpecialPlanList->Add(new TCellField(121, 0, 0x059D, 4, 1));	// Oi_UsiAMj
    mSpecialPlanList->Add(new TCellField(122, 0, 0x059D, 2, 1));	// TCh3UāiAMj
    mSpecialPlanList->Add(new TCellField(123, 0, 0x059D, 1, 1));	// TCh3UsiAMj
    mSpecialPlanList->Add(new TCellField(124, 0, 0x059E, 7, 1));	// lԊJvāiAMj
    mSpecialPlanList->Add(new TCellField(125, 0, 0x059E, 6, 1));	// lԊJvsiAMj
    mSpecialPlanList->Add(new TCellField(126, 0, 0x059E, 4, 1));	// \iAMj
    mSpecialPlanList->Add(new TCellField(127, 0, 0x059E, 3, 1));	// siAMj
    mSpecialPlanList->Add(new TCellField(128, 0, 0x059E, 1, 1));	// eXgpCbg̗pāiAMj
    mSpecialPlanList->Add(new TCellField(129, 0, 0x059F, 8, 1));	// eXgpCbg̗psiAMj
    mSpecialPlanList->Add(new TCellField(130, 0, 0x059F, 6, 1));	// K_JvāiAMj
    mSpecialPlanList->Add(new TCellField(131, 0, 0x059F, 5, 1));	// K_JvsiAMj
    mSpecialPlanList->Add(new TCellField(132, 0, 0x059F, 3, 1));	// ϊ͎āiAMj
    mSpecialPlanList->Add(new TCellField(133, 0, 0x059F, 2, 1));	// ϊ͎siAMj
    mSpecialPlanList->Add(new TCellField(134, 0, 0x05A0, 8, 1));	// eB^[YāiAMj
    mSpecialPlanList->Add(new TCellField(135, 0, 0x05A0, 7, 1));	// eB^[YsiAMj
    mSpecialPlanList->Add(new TCellField(136, 0, 0x05A0, 5, 1));	// yvāiAMj
    mSpecialPlanList->Add(new TCellField(137, 0, 0x05A0, 4, 1));	// yvsiAMj
    mSpecialPlanList->Add(new TCellField(138, 0, 0x05A1, 8, 1));	// I[KX^ݗāiAMj
    mSpecialPlanList->Add(new TCellField(139, 0, 0x05A1, 7, 1));	// I[KX^ݗsiAMj
    mSpecialPlanList->Add(new TCellField(140, 0, 0x05A1, 5, 1));	// TݗāiAMj
    mSpecialPlanList->Add(new TCellField(141, 0, 0x05A1, 4, 1));	// TݗsiAMj
    mSpecialPlanList->Add(new TCellField(142, 0, 0x05A1, 2, 1));	// TCh3āiAMj
    mSpecialPlanList->Add(new TCellField(143, 0, 0x05A1, 1, 1));	// TCh3siAMj
    mSpecialPlanList->Add(new TCellField(144, 0, 0x05A2, 7, 1));	// OvX2[΃W~gt]iAMj
    mSpecialPlanList->Add(new TCellField(145, 0, 0x05A2, 6, 1));	// OvX2s[΃W~gt]iAMj
    mSpecialPlanList->Add(new TCellField(146, 0, 0x05A2, 4, 1));	// OvX2[΃VbR]iAMj
    mSpecialPlanList->Add(new TCellField(147, 0, 0x05A2, 3, 1));	// OvX2s[΃VbR]iAMj
    mSpecialPlanList->Add(new TCellField(148, 0, 0x05A3, 6, 1));	// rA[YāiAMj
    mSpecialPlanList->Add(new TCellField(149, 0, 0x05A3, 5, 1));	// rA[YsiAMj
    mSpecialPlanList->Add(new TCellField(150, 0, 0x05A3, 3, 1));	// ̉āiAMj
    mSpecialPlanList->Add(new TCellField(151, 0, 0x05A3, 2, 1));	// ̉siAMj
    mSpecialPlanList->Add(new TCellField(152, 0, 0x05A4, 8, 1));	// ANVYāiAMj
    mSpecialPlanList->Add(new TCellField(153, 0, 0x05A4, 7, 1));	// ANVYsiAMj
	// ANVY
    mSpecialPlanList->Add(new TCellField(155, 0, 0x05A4, 5, 1));	// OvX2[΃VbR]iANVYj
    mSpecialPlanList->Add(new TCellField(156, 0, 0x05A4, 4, 1));	// OvX2s[΃VbR]iANVYj
    mSpecialPlanList->Add(new TCellField(157, 0, 0x05A5, 8, 1));	// rA[YāiANVYj
    mSpecialPlanList->Add(new TCellField(158, 0, 0x05A5, 7, 1));	// rA[YsiANVYj
    mSpecialPlanList->Add(new TCellField(159, 0, 0x05A5, 5, 1));	// \iANVYj
    mSpecialPlanList->Add(new TCellField(160, 0, 0x05A5, 4, 1));	// siANVYj
	// GD[S
    mSpecialPlanList->Add(new TCellField(162, 0, 0x05A5, 2, 1));	// OvX2[΃W~gt]iGD[Sj
    mSpecialPlanList->Add(new TCellField(163, 0, 0x05A5, 1, 1));	// OvX2s[΃W~gt]iGD[Sj
    mSpecialPlanList->Add(new TCellField(164, 0, 0x05A6, 7, 1));	// ANVYāiGD[Sj
    mSpecialPlanList->Add(new TCellField(165, 0, 0x05A6, 6, 1));	// ANVYsiGD[Sj
    mSpecialPlanList->Add(new TCellField(166, 0, 0x05A6, 4, 1));	// \iGD[Sj
    mSpecialPlanList->Add(new TCellField(167, 0, 0x05A6, 3, 1));	// siGD[Sj
	// eB^[YiW~gtj
    mSpecialPlanList->Add(new TCellField(169, 0, 0x05A7, 6, 1));	// rA[YāiW~gtj
    mSpecialPlanList->Add(new TCellField(170, 0, 0x05A7, 5, 1));	// rA[YsiW~gtj
    mSpecialPlanList->Add(new TCellField(171, 0, 0x05A7, 3, 1));	// ANVYāiW~gtj
    mSpecialPlanList->Add(new TCellField(172, 0, 0x05A7, 2, 1));	// ANVYsiW~gtj
    mSpecialPlanList->Add(new TCellField(173, 0, 0x05A8, 8, 1));	// \iW~gtj
    mSpecialPlanList->Add(new TCellField(174, 0, 0x05A8, 7, 1));	// siW~gtj
	// eB^[YiVbRj
    mSpecialPlanList->Add(new TCellField(176, 0, 0x05A8, 5, 1));	// rA[YāiVbRj
    mSpecialPlanList->Add(new TCellField(177, 0, 0x05A8, 4, 1));	// rA[YsiVbRj
    mSpecialPlanList->Add(new TCellField(178, 0, 0x05A9, 8, 1));	// ANVYāiVbRj
    mSpecialPlanList->Add(new TCellField(179, 0, 0x05A9, 7, 1));	// ANVYsiVbRj
    mSpecialPlanList->Add(new TCellField(180, 0, 0x05A9, 5, 1));	// \iVbRj
    mSpecialPlanList->Add(new TCellField(181, 0, 0x05A9, 4, 1));	// siVbRj
	// f[Yt[g
    mSpecialPlanList->Add(new TCellField(183, 0, 0x05A9, 2, 1));	// OvX2[΃W~gt]if[Yt[gj
    mSpecialPlanList->Add(new TCellField(184, 0, 0x05A9, 1, 1));	// OvX2s[΃W~gt]if[Yt[gj
    mSpecialPlanList->Add(new TCellField(185, 0, 0x05AA, 7, 1));	// Wu[āif[Yt[gj
    mSpecialPlanList->Add(new TCellField(186, 0, 0x05AA, 6, 1));	// Wu[sif[Yt[gj
    mSpecialPlanList->Add(new TCellField(187, 0, 0x05AA, 4, 1));	// \if[Yt[gj
    mSpecialPlanList->Add(new TCellField(188, 0, 0x05AA, 3, 1));	// sif[Yt[gj
	// lIWI
    mSpecialPlanList->Add(new TCellField(190, 0, 0x05AA, 1, 1));	// TCh3āilIWIj
    mSpecialPlanList->Add(new TCellField(191, 0, 0x05AB, 8, 1));	// TCh3silIWIj
    mSpecialPlanList->Add(new TCellField(192, 0, 0x05AB, 6, 1));	// Wu[āilIWIj
    mSpecialPlanList->Add(new TCellField(193, 0, 0x05AB, 5, 1));	// Wu[silIWIj
    mSpecialPlanList->Add(new TCellField(194, 0, 0x05AB, 3, 1));	// \ilIWIj
    mSpecialPlanList->Add(new TCellField(195, 0, 0x05AB, 2, 1));	// silIWIj
	// VWI
    mSpecialPlanList->Add(new TCellField(197, 0, 0x05AC, 8, 1));	// Oi_[΃lIWI]iVWIj
    mSpecialPlanList->Add(new TCellField(198, 0, 0x05AC, 7, 1));	// Oi_s[΃lIWI]iVWIj
    mSpecialPlanList->Add(new TCellField(199, 0, 0x05AC, 5, 1));	// Wu[āiVWIj
    mSpecialPlanList->Add(new TCellField(200, 0, 0x05AC, 4, 1));	// Wu[siVWIj
    mSpecialPlanList->Add(new TCellField(201, 0, 0x05AD, 8, 1));	// \iVWIj
    mSpecialPlanList->Add(new TCellField(202, 0, 0x05AD, 7, 1));	// siVWIj
	// WI
    mSpecialPlanList->Add(new TCellField(204, 0, 0x05AD, 5, 1));	// TCh3āiWIj
    mSpecialPlanList->Add(new TCellField(205, 0, 0x05AD, 4, 1));	// TCh3siWIj
    mSpecialPlanList->Add(new TCellField(206, 0, 0x05AD, 2, 1));	// Wu[āiWIj
    mSpecialPlanList->Add(new TCellField(207, 0, 0x05AD, 1, 1));	// Wu[siWIj
    mSpecialPlanList->Add(new TCellField(208, 0, 0x05AE, 7, 1));	// \iWIj
    mSpecialPlanList->Add(new TCellField(209, 0, 0x05AE, 6, 1));	// siWIj
	// ؗȂ킢
    mSpecialPlanList->Add(new TCellField(211, 0, 0x05AE, 4, 1));	// OvX2[΃W~gt]iؗȂ킢j
    mSpecialPlanList->Add(new TCellField(212, 0, 0x05AE, 3, 1));	// OvX2s[΃W~gt]iؗȂ킢j
    mSpecialPlanList->Add(new TCellField(213, 0, 0x05AE, 1, 1));	// Wu[āiؗȂ킢j
    mSpecialPlanList->Add(new TCellField(214, 0, 0x05AF, 8, 1));	// Wu[siؗȂ킢j
    mSpecialPlanList->Add(new TCellField(215, 0, 0x05AF, 6, 1));	// \iؗȂ킢j
    mSpecialPlanList->Add(new TCellField(216, 0, 0x05AF, 5, 1));	// siؗȂ킢j
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitPlan()
{
    // Jv\̏ݒ
    TStringGrid *theGridPtr[] = {StringGrid1_1, StringGrid2_1, StringGrid3_1};

    TGridRect theRect;
    theRect.Left = 2;
    theRect.Top = 1;
    theRect.Right = 2;
    theRect.Bottom = 1;

    const int         PlanGridColumn  = 3;
    const char *const PlanGridTitle[] = {"O", "", "^["};
    const int         PlanGridWidth[] = {200, 40, 40};

    for (int i = 0; i < 3; i++) {
        theGridPtr[i]->Selection = theRect;
        // ^CgƗ񕝂̐ݒ
        for (int j = 0; j < PlanGridColumn; j++) {
            theGridPtr[i]->Cells[j][0] = PlanGridTitle[j];
            theGridPtr[i]->ColWidths[j] = PlanGridWidth[j];
        }
        // Jv̐ݒ
        for (int j = 0; j < mPlanNameList->Count; j++) {
            theGridPtr[i]->Cells[0][j + 1] = mPlanNameList->Strings[j];
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitUnit()
{
    // \̏ݒ
    TStringGrid *theGridPtr[] = {StringGrid1_2, StringGrid2_2, StringGrid3_2};

    const int         UnitGridColumn  = 20;
    const char *const UnitGridTitle[] = {"No", "ID", "O", "ϋv", "", "J", "mC", "ID", "pCbg", "ID", "GA", "", "ڐ", "ړ", "ID", "ړ", "퓬", "XW", "YW", "X^bN"};
    const int         UnitGridWidth[] = {30, 30, 165, 30, 30, 30, 30, 30, 165, 30, 70, 30, 40, 30, 30, 70, 40, 40, 40, 40};

    for (int i = 0; i < 3; i++) {
        // ^CgƗ񕝂̐ݒ
        for (int j = 0; j < UnitGridColumn; j++) {
            theGridPtr[i]->Cells[j][0] = UnitGridTitle[j];
            theGridPtr[i]->ColWidths[j] = UnitGridWidth[j];
        }
        // No̐ݒ
        for (int j = 0; j < 200; j++) {
            theGridPtr[i]->Cells[0][j + 1] = j;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitPilot()
{
    // pCbg\̏ݒ
    TStringGrid *theGridPtr = StringGrid4_1;

    TGridRect theRect;
    theRect.Left = 1;
    theRect.Top = 1;
    theRect.Right = 1;
    theRect.Bottom = 1;
    theGridPtr->Selection = theRect;

    const int         PilotGridColumn  = 15;
    const char *const PilotGridTitle[] = {"O", "ID", "GA", "", "ID", "", "ID", "", "ID", "K", "", "o", "mCH", "A^[", "H"};
    const int         PilotGridWidth[] = {180, 30, 80, 30, 20, 50, 20, 70, 20, 50, 30, 30, 30, 30, 20};
    
    // ^CgƗ񕝂̐ݒ
    for (int i = 0; i < PilotGridColumn; i++) {
        theGridPtr->Cells[i][0] = PilotGridTitle[i];
        theGridPtr->ColWidths[i] = PilotGridWidth[i];
    }
    // pCbg̐ݒ
    for (int i = 0; i < mPilotNameList->Count; i++) {
        theGridPtr->Cells[0][i + 1] = mPilotNameList->Strings[i];
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitSpecialArea()
{
    // ʃGA\̏ݒ
    TStringGrid *theGridPtr = StringGrid5_1;

    const int         SpecialAreaGridColumn  = 5;
    const char *const SpecialAreaGridTitle[] = {"O", "No", "ID", "O", "^["};
    const int         SpecialAreaGridWidth[] = {80, 20, 30, 140, 40};

    // ^CgƗ񕝂̐ݒ
    for (int i = 0; i < SpecialAreaGridColumn; i++) {
        theGridPtr->Cells[i][0] = SpecialAreaGridTitle[i];
        theGridPtr->ColWidths[i] = SpecialAreaGridWidth[i];
    }

    const int theIndex[] = {4, 5, 8, 11, 18, 26, 30, 32, 37, 41, 42, 43, 44, 45, 49, 74, 75, 76, 77};
    int theRow = 1;
    for (int i = 0; i < 19; i++) {
        theGridPtr->Cells[0][theRow] = mAreaNameList->Strings[theIndex[i]];
        for (int j = 0; j < 8; j++) {
            theGridPtr->Cells[1][theRow] = j + 1;
            theRow++;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitArea()
{
    // GA\̏ݒ
    TStringGrid *theGridPtr = StringGrid5_2;
    AnsiString theStr;
    int thePos;

    const int         AreaGridColumn  = 13;
    const char *const AreaGridTitle[] = {"O",  "퓬",  "xz",  "H",  "_1",  "_2",  "_3",  "_4",  "_5",  "_6",  "_7",  "_8",  "_"};
    const int         AreaGridWidth[] = {90,  50,  50,  50,  40,  40,  40,  40,  40,  40,  40,  40,  40};

    // ^CgƗ񕝂̐ݒ
    for (int i = 0; i < AreaGridColumn; i++) {
        theGridPtr->Cells[i][0] = AreaGridTitle[i];
        theGridPtr->ColWidths[i] = AreaGridWidth[i];
    }

    for (int i = 0; i < mAreaNameList->Count; i++) {
        theStr = mAreaNameList->Strings[i];
        thePos = AnsiPos("\t", theStr);
        mAreaNameList->Strings[i] = theStr.SubString(0, thePos - 1);
        theGridPtr->Cells[0][i + 1] = mAreaNameList->Strings[i];
        theGridPtr->Cells[12][i + 1] = theStr.SubString(thePos + 1, theStr.Length() - thePos);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitSpecialPlan()
{
    // ʃv\̏ݒ
    TCheckListBox *theCheckListPtr = CheckListBox6_1;

    theCheckListPtr->Items->AddStrings(mSpecialPlan);

    theCheckListPtr->Header[0]   = true;	// WI
    theCheckListPtr->Header[85]  = true;	// nAMR
    theCheckListPtr->Header[154] = true;	// ANVY
    theCheckListPtr->Header[161] = true;	// GD[S
    theCheckListPtr->Header[168] = true;	// eB^[YiW~gtj
    theCheckListPtr->Header[175] = true;	// eB^[YiVbRj
    theCheckListPtr->Header[182] = true;	// f[Yt[g
    theCheckListPtr->Header[189] = true;	// lIWI
    theCheckListPtr->Header[196] = true;	// VWI
    theCheckListPtr->Header[203] = true;	// WI
    theCheckListPtr->Header[210] = true;	// ؗȂ킢

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::InitWeapon()
{
    // ꗗ\̏ݒ
    TStringGrid *theGridPtr = StringGrid7_1;
    AnsiString theStr;
    int thePos;

    const int         WeaponGridColumn  = 5;
    const char *const WeaponGridTitle[] = {"O", "", "őϋv", "ő啨", ""};
    const int         WeaponGridWidth[] = {250, 60, 60, 60, 30};
    // ^CgƗ񕝂̐ݒ
    for (int i = 0; i < WeaponGridColumn; i++) {
        theGridPtr->Cells[i][0] = WeaponGridTitle[i];
        theGridPtr->ColWidths[i] = WeaponGridWidth[i];
    }

    for (int i = 0; i < mUnitNameList->Count; i++) {
        theStr = mUnitNameList->Strings[i];
        thePos = theStr.AnsiPos("\t");
        mUnitNameList->Strings[i] = theStr.SubString(0, thePos - 1);
        theGridPtr->Cells[0][i + 1] = mUnitNameList->Strings[i];

        for (int j = 0; j < 4; j++) {
            theStr = theStr.Delete(1, thePos);
            thePos = AnsiPos("\t", theStr);
            if (thePos != 0) {
                theGridPtr->Cells[j + 1][i + 1] = theStr.SubString(0, thePos - 1);
            } else {
                theGridPtr->Cells[j + 1][i + 1] = theStr;
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ShowHexDump()
{
    // PUi_v̕\
    AnsiString theDumpStr, theStr;

    theDumpStr += "FileName = ";
    theDumpStr += mSaveDataPath;
    theDumpStr += "\r\n";

    theDumpStr += "Size = ";
    theDumpStr += mSaveDataSize;
    theDumpStr += " Byte\r\n";

    theDumpStr += "\r\n";
    theDumpStr += "ADDRESS  +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F";
    for (int i = 0; i < mSaveDataSize; i++) {
        if (i % 16 == 0) {
            theDumpStr += "\r\n";
            theDumpStr += IntToHex(i, 8);
        }
        theDumpStr += " ";
        theStr = IntToHex(mSaveData[i], 3);
        theDumpStr += theStr.SubString(theStr.Length()-1,2);
    }
    HexDumpForm->HexDump->Clear();
    HexDumpForm->HexDump->Text = theDumpStr;
    HexDumpForm->Show();
    //MainForm->Show();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SaveDataRead()
{
    // Z[uf[^lǂݏo
    TField *theFieldPtr;
    TControl *theCntPtr;

    for (int i = 0; i < mFieldList->Count; i++) {
        theFieldPtr = (TField *)mFieldList->Items[i];
        theCntPtr = theFieldPtr->ControlPtr;

        if (theCntPtr) {
            if (theCntPtr->ClassNameIs("TEdit")) {
                ((TEdit *)theCntPtr)->Text = DataRead(*theFieldPtr);
            } else if (theCntPtr->ClassNameIs("TCheckBox")) {
                ((TCheckBox *)theCntPtr)->Checked = DataRead(*theFieldPtr);
            } else if (theCntPtr->ClassNameIs("TComboBox")) {
                if (theCntPtr == ComboBox1_1 || theCntPtr == ComboBox2_1 || theCntPtr == ComboBox3_1) {
                    ForceDataRead(*theFieldPtr);
                } else if (theCntPtr == ComboBox6_1) {
                    SectionDataRead(*theFieldPtr);
                }
            } else if (theCntPtr->ClassNameIs("TCheckListBox")) {
                SpecialPlanDataRead(*theFieldPtr);
            } else if (theCntPtr->ClassNameIs("TStringGrid")) {
                if (theCntPtr == StringGrid1_1 || theCntPtr == StringGrid2_1 || theCntPtr == StringGrid3_1) {
                    PlanDataRead(*theFieldPtr);
                } else if (theCntPtr == StringGrid1_2 || theCntPtr == StringGrid2_2 || theCntPtr == StringGrid3_2) {
                    UnitDataRead(*theFieldPtr);
                } else if (theCntPtr == StringGrid4_1) {
                    PilotDataRead(*theFieldPtr);
                } else if (theCntPtr == StringGrid5_1) {
                    SpecialAreaDataRead(*theFieldPtr);
                } else if (theCntPtr == StringGrid5_2) {
                    AreaDataRead(*theFieldPtr);
                }
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ForceDataRead(const TField &field)
{
    // ͖̃f[^ǂݍ
    TComboBox *theCntPtr = (TComboBox *)field.ControlPtr;
    int theValue;

    theValue = DataRead(field);
    if (0 <= theValue && theValue <= 9) {
        ((TComboBox *)theCntPtr)->ItemIndex = theValue;
    } else {
        ((TComboBox *)theCntPtr)->ItemIndex = 10;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PlanDataRead(const TField &field)
{
    // Jṽf[^ǂݍ
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;

    TField theState, theTurn;
    int theValue;

    theState = field;
    theState.Width = 4;

    theTurn = field;
    theTurn.Offset(4);
    theTurn.Width = 5;

    for (int i = 0; i < 265; i++) {
        // Ԃǂݏo
        theValue = DataRead(theState);
        switch (theValue) {
            case 0: // 
                theGridPtr->Cells[1][i + 1] = PlanStateStr[0];
                break;
            case 1: // ^[
                theGridPtr->Cells[1][i + 1] = PlanStateStr[1];
                break;
            case 2: // NEW
                theGridPtr->Cells[1][i + 1] = PlanStateStr[2];
                break;
            case 5: // J
                theGridPtr->Cells[1][i + 1] = PlanStateStr[3];
                break;
            case 6: // ǉ
                theGridPtr->Cells[1][i + 1] = PlanStateStr[4];
                break;
            case 7: // END
                theGridPtr->Cells[1][i + 1] = PlanStateStr[5];
                break;
            default:
                theGridPtr->Cells[1][i + 1] = theValue + "?";
        }
        // c^[ǂݏo
        theValue = DataRead(theTurn);
        theGridPtr->Cells[2][i + 1] = theValue;

        theState.Offset(field.Width);
        theTurn.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::UnitDataRead(const TField &field)
{
    // ̃f[^ǂݍ
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField theUnit, theField;
    int theValue;

    theUnit = field;
    for (int i = 0; i < 200 ; i++) {
        // @̔ԍ
        theField = theUnit;
        theField.Width = 9;
        theValue = DataRead(theField);
        theGridPtr->Cells[1][i + 1] = theValue;
        if (0 <= theValue && theValue < mUnitNameList->Count) {
            theGridPtr->Cells[2][i + 1] = mUnitNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[2][i + 1] = "";
        }
        // ϋv
        theField = theUnit;
        theField.Offset(155);
        theField.Width = 10;
        theValue = DataRead(theField);
        theGridPtr->Cells[3][i + 1] = theValue;
        // 
        theField = theUnit;
        theField.Offset(165);
        theField.Width = 10;
        theValue = DataRead(theField);
        theGridPtr->Cells[4][i + 1] = theValue;
        // J
        theField = theUnit;
        theField.Offset(140);
        theField.Width = 7;
        theValue = DataRead(theField);
        theGridPtr->Cells[5][i + 1] = theValue;
        // mC
        theField = theUnit;
        theField.Offset(147);
        theField.Width = 7;
        theValue = DataRead(theField);
        theGridPtr->Cells[6][i + 1] = theValue;
        // pCbg
        theField = theUnit;
        theField.Offset(9);
        theField.Width = 8;
        theValue = DataRead(theField);
        theGridPtr->Cells[7][i + 1] = theValue;
        if (0 <= theValue && theValue < mPilotNameList->Count) {
            theGridPtr->Cells[8][i + 1] = mPilotNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[8][i + 1] = "";
        }
        // GA
        theField = theUnit;
        theField.Offset(17);
        theField.Width = 7;
        theValue = DataRead(theField);
        theGridPtr->Cells[9][i + 1] = theValue;
        if (0 <= theValue && theValue < mAreaNameList->Count) {
            theGridPtr->Cells[10][i + 1] = mAreaNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[10][i + 1] = "";
        }
        // ڏ
        theField = theUnit;
        theField.Offset(130);
        theField.Width = 1;
        theValue = DataRead(theField);
        theGridPtr->Cells[11][i + 1] = theValue;
        // ڐ
        theField = theUnit;
        theField.Offset(131);
        theField.Width = 8;
        theValue = DataRead(theField);
        theGridPtr->Cells[12][i + 1] = theValue;
        // ړ
        theField = theUnit;
        theField.Offset(24);
        theField.Width = 3;
        theValue = DataRead(theField);
        if (0 <= theValue && theValue < 6) {
            theGridPtr->Cells[13][i + 1] = UnitMoveTypeStr[theValue];
        } else {
            theGridPtr->Cells[13][i + 1] = theValue + "?";
        }
        // ړ
        theField = theUnit;
        theField.Offset(27);
        theField.Width = 7;
        theValue = DataRead(theField);
        theGridPtr->Cells[14][i + 1] = theValue;
        if (0 <= theValue && theValue < mAreaNameList->Count) {
            theGridPtr->Cells[15][i + 1] = mAreaNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[15][i + 1] = "";
        }
        // 퓬MAPL
        theField = theUnit;
        theField.Offset(114);
        theField.Width = 1;
        theValue = DataRead(theField);
        theGridPtr->Cells[16][i + 1] = theValue;
        // XW
        theField = theUnit;
        theField.Offset(115);
        theField.Width = 5;
        theValue = DataRead(theField);
        theGridPtr->Cells[17][i + 1] = theValue;
        // YW
        theField = theUnit;
        theField.Offset(120);
        theField.Width = 5;
        theValue = DataRead(theField);
        theGridPtr->Cells[18][i + 1] = theValue;
        // X^bN
        theField = theUnit;
        theField.Offset(125);
        theField.Width = 2;
        theValue = DataRead(theField);
        theGridPtr->Cells[19][i + 1] = theValue;

        theUnit.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PilotDataRead(const TField &field)
{
    // pCbg̃f[^ǂݍ
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField thePilot, theField;
    int theValue;

    thePilot = field;
    for (int i = 0; i < 200 ; i++) {
        // GA
        theField = thePilot;
        theField.Width = 7;
        theValue = DataRead(theField);
        theGridPtr->Cells[1][i + 1] = theValue;
        if (0 <= theValue && theValue < mAreaNameList->Count) {
            theGridPtr->Cells[2][i + 1] = mAreaNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[2][i + 1] = "";
        }
        // 撆
        theField = thePilot;
        theField.Offset(12);
        theField.Width = 1;
        theValue = DataRead(theField);
        theGridPtr->Cells[3][i + 1] = theValue;
        // 
        theField = thePilot;
        theField.Offset(7);
        theField.Width = 2;
        theValue = DataRead(theField);
        theGridPtr->Cells[4][i + 1] = theValue;
        if (0 <= theValue && theValue < 3) {
            theGridPtr->Cells[5][i + 1] = PilotAffiliationStr[theValue];
        } else {
            theGridPtr->Cells[5][i + 1] = "";
        }
        // 
        theField = thePilot;
        theField.Offset(9);
        theField.Width = 3;
        theValue = DataRead(theField);
        theGridPtr->Cells[6][i + 1] = theValue;
        if (0 <= theValue && theValue < 5) {
            theGridPtr->Cells[7][i + 1] = PilotConditionStr[theValue];
        } else {
            theGridPtr->Cells[7][i + 1] = "";
        }
        // K
        theField = thePilot;
        theField.Offset(17);
        theField.Width = 4;
        theValue = DataRead(theField);
        theGridPtr->Cells[8][i + 1] = theValue;
        if (0 <= theValue && theValue < mClassList->Count) {
            theGridPtr->Cells[9][i + 1] = mClassList->Strings[theValue];
        } else {
            theGridPtr->Cells[9][i + 1] = "";
        }
        // 
        theField = thePilot;
        theField.Offset(21);
        theField.Width = 7;
        theValue = DataRead(theField);
        theGridPtr->Cells[10][i + 1] = theValue;
        // o
        theField = thePilot;
        theField.Offset(42);
        theField.Width = 10;
        theValue = DataRead(theField);
        theGridPtr->Cells[11][i + 1] = theValue;
        // mC
        theField = thePilot;
        theField.Offset(28);
        theField.Width = 7;
        theValue = DataRead(theField);
        theGridPtr->Cells[12][i + 1] = theValue;
        // A^[
        theField = thePilot;
        theField.Offset(35);
        theField.Width = 5;
        theValue = DataRead(theField);
        theGridPtr->Cells[13][i + 1] = theValue;
        // H
        theField = thePilot;
        theField.Offset(13);
        theField.Width = 4;
        theValue = DataRead(theField);
        theGridPtr->Cells[14][i + 1] = theValue;

        thePilot.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SpecialAreaDataRead(const TField &field)
{
    // ʃGÃf[^ǂݍ
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField theSpecialArea, theID, theTurn;
    int theValue, theRow = 1;

    theSpecialArea = field;

    for (int i = 0; i < 19 ; i++) {
        theID = theSpecialArea;
        theID.Width = 9;

        theTurn = theSpecialArea;
        theTurn.Offset(72);
        theTurn.Width = 5;

        for (int j = 0; j < 8; j++) {
            // @̔ԍ
            theValue = DataRead(theID);
            theGridPtr->Cells[2][theRow] = theValue;
            if (0 <= theValue && theValue < mUnitNameList->Count) {
                theGridPtr->Cells[3][theRow] = mUnitNameList->Strings[theValue];
            } else {
                theGridPtr->Cells[3][theRow] = "";
            }
            // ^[
            theValue = DataRead(theTurn);
            theGridPtr->Cells[4][theRow] = theValue;

            theID.Offset(9);
            theTurn.Offset(5);
            theRow++;
        }
        
        theSpecialArea.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AreaDataRead(const TField &field)
{
    // GÃf[^ǂݍ
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField theArea, theField;
    int theValue;

    theArea = field;
    for (int i = 0; i < 78 ; i++) {
        // 풆
        theField = theArea;
        theField.Offset(1);
        theField.Width = 2;
        theValue = DataRead(theField);
        if (0 <= theValue && theValue < 2) {
            theGridPtr->Cells[1][i + 1] = AreaBattleStateStr[theValue];
        } else {
            theGridPtr->Cells[1][i + 1] = theValue + "?";
        }
        // xz
        theField = theArea;
        theField.Offset(3);
        theField.Width = 2;
        theValue = DataRead(theField);
        if (0 <= theValue && theValue < 4) {
            theGridPtr->Cells[2][i + 1] = AreaAffiliationStr[theValue];
        } else {
            theGridPtr->Cells[2][i + 1] = "";
        }
        // h䑤
        theField = theArea;
        theField.Offset(5);
        theField.Width = 2;
        theValue = DataRead(theField);
        if (0 <= theValue && theValue < 4) {
            theGridPtr->Cells[3][i + 1] = AreaAffiliationStr[theValue];
        } else {
            theGridPtr->Cells[3][i + 1] = "";
        }
        // _P`W
        theField = theArea;
        theField.Offset(7);
        theField.Width = 2;
        for (int j = 0; j < 8; j++) {
            theValue = DataRead(theField);
            if (0 <= theValue && theValue < 4) {
                theGridPtr->Cells[4 + j][i + 1] = AreaAffiliationStr[theValue];
            } else {
                theGridPtr->Cells[4 + j][i + 1] = "";
            }
            theField.Offset(2);
        }

        theArea.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SectionDataRead(const TField &field)
{
    // P/Q̃f[^ǂݍ
    TComboBox *theCntPtr = (TComboBox *)field.ControlPtr;
    int the1stData, the2ndData, the3rdData;

    the1stData = DataRead(TField(theCntPtr, 0x0011, 3, 1));
    the2ndData = DataRead(TField(theCntPtr, 0x0010, 1, 1));
    the3rdData = DataRead(TField(theCntPtr, 0x0010, 0, 1));
    if (the1stData == 1 && the2ndData == 0 && the3rdData == 0) {
        theCntPtr->ItemIndex = 0;
    } else if (the1stData == 0 && the2ndData == 1 && the3rdData == 0) {
        theCntPtr->ItemIndex = 1;
    } else if (the1stData == 0 && the2ndData == 1 && the3rdData == 1) {
        theCntPtr->ItemIndex = 2;
    } else {
        theCntPtr->ItemIndex = -1;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SpecialPlanDataRead(const TField &field)
{
    // ʃṽf[^ǂݍ
    TCheckListBox *theCheckListPtr = (TCheckListBox *)field.ControlPtr;
    TField theField;
    TCellField *theCellFieldPtr;
    int theValue;

    for (int i = 0; i < mSpecialPlanList->Count; i++) {
        theCellFieldPtr = (TCellField *)mSpecialPlanList->Items[i];
        theField.Address = theCellFieldPtr->Address;
        theField.Bit = theCellFieldPtr->Bit;
        theField.Width = theCellFieldPtr->Width;

        theValue = DataRead(theField);

        theCheckListPtr->Checked[theCellFieldPtr->Row] = theValue;
    }
}
//---------------------------------------------------------------------------

unsigned long __fastcall TMainForm::DataRead(const TField &field)
{
    unsigned long theLong;
    char *theChar;
    theChar = (char *)&theLong;
    // GfBA̕ύXirbO->gj
    for (int i = 0; i < 4; i++) {
        if (field.Address + i < mSaveDataSize) {
            theChar[3 - i] = mSaveData[field.Address + i];
        } else {
            theChar[3 - i] = 0;
        }
    }
    // Kvȃrbg̐؂o
    theLong = theLong << field.Bit;
    theLong = theLong >> (32 - field.Width);

    // fobOmFp
    //AnsiString theMsg;
    //theMsg.printf("%8x", theLong);
    //ShowMessage(theMsg);

    return theLong;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SaveDataWrite()
{
    // Z[uf[^ɒl
    TControl *theCntPtr;
    TField *theFieldPtr;
    AnsiString theText;

    for (int i = 0; i < mFieldList->Count; i++) {
        theFieldPtr = (TField *)mFieldList->Items[i];
        theCntPtr = theFieldPtr->ControlPtr;
        if (theCntPtr) {
            if (theCntPtr->ClassNameIs("TEdit")) {
                DataWrite(*theFieldPtr, ((TEdit *)theCntPtr)->Text.ToInt());
            } else if (theCntPtr->ClassNameIs("TCheckBox")) {
                DataWrite(*theFieldPtr, ((TCheckBox *)theCntPtr)->Checked);

            } else if (theCntPtr->ClassNameIs("TComboBox")) {
                if (theCntPtr == ComboBox1_1 || theCntPtr == ComboBox2_1 || theCntPtr == ComboBox3_1) {
                    ForceDataWrite(*theFieldPtr);
                } else if (theCntPtr == ComboBox6_1) {
                    SectionDataWrite(*theFieldPtr);
                }
            } else if (theCntPtr->ClassNameIs("TCheckListBox")) {
                SpecialPlanDataWrite(*theFieldPtr);
            } else if (theCntPtr->ClassNameIs("TStringGrid")) {
                if (theCntPtr == StringGrid1_1 || theCntPtr == StringGrid2_1 || theCntPtr == StringGrid3_1) {
                    PlanDataWrite(*theFieldPtr);
                } else if (theCntPtr == StringGrid1_2 || theCntPtr == StringGrid2_2 || theCntPtr == StringGrid3_2) {
                    UnitDataWrite(*theFieldPtr);
                } else if (theCntPtr == StringGrid4_1) {
                    PilotDataWrite(*theFieldPtr);
                } else if (theCntPtr == StringGrid5_1) {
                    SpecialAreaDataWrite(*theFieldPtr);
                } else if (theCntPtr == StringGrid5_2) {
                    AreaDataWrite(*theFieldPtr);
                }
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ForceDataWrite(const TField &field)
{
    // ͖̃f[^
    TComboBox *theCntPtr = (TComboBox *)field.ControlPtr;
    int theValue;

    theValue = theCntPtr->ItemIndex;
    if (9 < theValue) {
        theValue = 15;
    }
    DataWrite(field, theValue);

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PlanDataWrite(const TField &field)
{
    // Jṽf[^
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField theState, theTurn;
    int theValue;

    theState = field;
    theState.Width = 4;

    theTurn = field;
    theTurn.Offset(4);
    theTurn.Width = 5;

    for (int i = 0; i < 265; i++) {
        theValue = theGridPtr->Cells[2][i + 1].ToInt();
        if (theGridPtr->Cells[1][i + 1] == PlanStateStr[0]) {
            DataWrite(theState, 0);
            DataWrite(theTurn, 0);
            theGridPtr->Cells[2][i + 1] = 0;
        } else if (theGridPtr->Cells[1][i + 1] == PlanStateStr[1]) {
            DataWrite(theState, 1);
            DataWrite(theTurn, theValue);
        } else if (theGridPtr->Cells[1][i + 1] == PlanStateStr[2]) {
            DataWrite(theState, 2);
            DataWrite(theTurn, theValue);
        } else if (theGridPtr->Cells[1][i + 1] == PlanStateStr[3]) {
            DataWrite(theState, 5);
            DataWrite(theTurn, theValue);
        } else if (theGridPtr->Cells[1][i + 1] == PlanStateStr[4]) {
            DataWrite(theState, 6);
            DataWrite(theTurn, theValue);
        } else if (theGridPtr->Cells[1][i + 1] == PlanStateStr[5]) {
            DataWrite(theState, 7);
            DataWrite(theTurn, 0);
            theGridPtr->Cells[2][i + 1] = 0;
        }

        theState.Offset(field.Width);
        theTurn.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::UnitDataWrite(const TField &field)
{
    // ̃f[^
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField theUnit, theField;
    int theValue;

    theUnit = field;
    for (int i = 0; i < 200 ; i++) {
        // @̔ԍ
        theField = theUnit;
        theField.Width = 9;
        theValue = theGridPtr->Cells[1][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < mUnitNameList->Count) {
            theGridPtr->Cells[2][i + 1] = mUnitNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[2][i + 1] = "";
        }
        // ϋv
        theField = theUnit;
        theField.Offset(155);
        theField.Width = 10;
        theValue = theGridPtr->Cells[3][i + 1].ToInt();
        DataWrite(theField, theValue);
        // 
        theField = theUnit;
        theField.Offset(165);
        theField.Width = 10;
        theValue = theGridPtr->Cells[4][i + 1].ToInt();
        DataWrite(theField, theValue);
        // J
        theField = theUnit;
        theField.Offset(140);
        theField.Width = 7;
        theValue = theGridPtr->Cells[5][i + 1].ToInt();
        DataWrite(theField, theValue);
        // mC
        theField = theUnit;
        theField.Offset(147);
        theField.Width = 7;
        theValue = theGridPtr->Cells[6][i + 1].ToInt();
        DataWrite(theField, theValue);
        // pCbg
        theField = theUnit;
        theField.Offset(9);
        theField.Width = 8;
        theValue = theGridPtr->Cells[7][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < mPilotNameList->Count) {
            theGridPtr->Cells[8][i + 1] = mPilotNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[8][i + 1] = "";
        }
        // GA
        theField = theUnit;
        theField.Offset(17);
        theField.Width = 7;
        theValue = theGridPtr->Cells[9][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < mAreaNameList->Count) {
            theGridPtr->Cells[10][i + 1] = mAreaNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[10][i + 1] = "";
        }
        // ڏ
        theField = theUnit;
        theField.Offset(130);
        theField.Width = 1;
        theValue = theGridPtr->Cells[11][i + 1].ToInt();
        DataWrite(theField, theValue);
        // ڐ
        theField = theUnit;
        theField.Offset(131);
        theField.Width = 8;
        theValue = theGridPtr->Cells[12][i + 1].ToInt();
        DataWrite(theField, theValue);
        // ړ
        theField = theUnit;
        theField.Offset(24);
        theField.Width = 3;
        if (theGridPtr->Cells[13][i + 1] == UnitMoveTypeStr[0]) {
            theValue = 0;
        } else if (theGridPtr->Cells[13][i + 1] == UnitMoveTypeStr[1]) {
            theValue = 1;
        } else if (theGridPtr->Cells[13][i + 1] == UnitMoveTypeStr[2]) {
            theValue = 2;
        } else if (theGridPtr->Cells[13][i + 1] == UnitMoveTypeStr[3]) {
            theValue = 3;
        } else if (theGridPtr->Cells[13][i + 1] == UnitMoveTypeStr[4]) {
            theValue = 4;
        } else if (theGridPtr->Cells[13][i + 1] == UnitMoveTypeStr[5]) {
            theValue = 5;
        }
        DataWrite(theField, theValue);
        // ړ
        theField = theUnit;
        theField.Offset(27);
        theField.Width = 7;
        theValue = theGridPtr->Cells[14][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < mAreaNameList->Count) {
            theGridPtr->Cells[15][i + 1] = mAreaNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[15][i + 1] = "";
        }
        // 퓬MAPL
        theField = theUnit;
        theField.Offset(114);
        theField.Width = 1;
        theValue = theGridPtr->Cells[16][i + 1].ToInt();
        DataWrite(theField, theValue);
        // XW
        theField = theUnit;
        theField.Offset(115);
        theField.Width = 5;
        theValue = theGridPtr->Cells[17][i + 1].ToInt();
        DataWrite(theField, theValue);
        // YW
        theField = theUnit;
        theField.Offset(120);
        theField.Width = 5;
        theValue = theGridPtr->Cells[18][i + 1].ToInt();
        DataWrite(theField, theValue);
        // X^bN
        theField = theUnit;
        theField.Offset(125);
        theField.Width = 2;
        theValue = theGridPtr->Cells[19][i + 1].ToInt();
        DataWrite(theField, theValue);

        theUnit.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PilotDataWrite(const TField &field)
{
    // pCbg̃f[^
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField thePilot, theField;
    int theValue;

    thePilot = field;
    for (int i = 0; i < 200 ; i++) {
        // GA
        theField = thePilot;
        theField.Width = 7;
        theValue = theGridPtr->Cells[1][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < mAreaNameList->Count) {
            theGridPtr->Cells[2][i + 1] = mAreaNameList->Strings[theValue];
        } else {
            theGridPtr->Cells[2][i + 1] = "";
        }
        // 撆
        theField = thePilot;
        theField.Offset(12);
        theField.Width = 1;
        theValue = theGridPtr->Cells[3][i + 1].ToInt();
        DataWrite(theField, theValue);
        // 
        theField = thePilot;
        theField.Offset(7);
        theField.Width = 2;
        theValue = theGridPtr->Cells[4][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < 3) {
            theGridPtr->Cells[5][i + 1] = PilotAffiliationStr[theValue];
        } else {
            theGridPtr->Cells[5][i + 1] = "";
        }
        // 
        theField = thePilot;
        theField.Offset(9);
        theField.Width = 3;
        theValue = theGridPtr->Cells[6][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < 5) {
            theGridPtr->Cells[7][i + 1] = PilotConditionStr[theValue];
        } else {
            theGridPtr->Cells[7][i + 1] = "";
        }
        // K
        theField = thePilot;
        theField.Offset(17);
        theField.Width = 4;
        theValue = theGridPtr->Cells[8][i + 1].ToInt();
        DataWrite(theField, theValue);
        if (0 <= theValue && theValue < mClassList->Count) {
            theGridPtr->Cells[9][i + 1] = mClassList->Strings[theValue];
        } else {
            theGridPtr->Cells[9][i + 1] = "";
        }
        // 
        theField = thePilot;
        theField.Offset(21);
        theField.Width = 7;
        theValue = theGridPtr->Cells[10][i + 1].ToInt();
        DataWrite(theField, theValue);
        // o
        theField = thePilot;
        theField.Offset(42);
        theField.Width = 10;
        theValue = theGridPtr->Cells[11][i + 1].ToInt();
        DataWrite(theField, theValue);
        // mC
        theField = thePilot;
        theField.Offset(28);
        theField.Width = 7;
        theValue = theGridPtr->Cells[12][i + 1].ToInt();
        DataWrite(theField, theValue);
        // A^[
        theField = thePilot;
        theField.Offset(35);
        theField.Width = 5;
        theValue = theGridPtr->Cells[13][i + 1].ToInt();
        DataWrite(theField, theValue);
        // H
        theField = thePilot;
        theField.Offset(13);
        theField.Width = 4;
        theValue = theGridPtr->Cells[14][i + 1].ToInt();
        DataWrite(theField, theValue);

        thePilot.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SpecialAreaDataWrite(const TField &field)
{
    // ʃGÃf[^
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField theSpecialArea, theID, theTurn;
    int theValue, theRow = 1;

    theSpecialArea = field;

    for (int i = 0; i < 19 ; i++) {
        theID = theSpecialArea;
        theID.Width = 9;

        theTurn = theSpecialArea;
        theTurn.Offset(72);
        theTurn.Width = 5;

        for (int j = 0; j < 8; j++) {
            // @̔ԍ
            theValue = theGridPtr->Cells[2][theRow].ToInt();
            DataWrite(theID, theValue);
            if (0 <= theValue && theValue < mUnitNameList->Count) {
                theGridPtr->Cells[3][theRow] = mUnitNameList->Strings[theValue];
            } else {
                theGridPtr->Cells[3][theRow] = "";
            }
            // ^[
            theValue = theGridPtr->Cells[4][theRow].ToInt();
            DataWrite(theTurn, theValue);

            theID.Offset(9);
            theTurn.Offset(5);
            theRow++;
        }
        
        theSpecialArea.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AreaDataWrite(const TField &field)
{
    // GÃf[^
    TStringGrid *theGridPtr = (TStringGrid *)field.ControlPtr;
    TField theArea, theField;

    theArea = field;
    for (int i = 0; i < 78 ; i++) {
        // 풆
        theField = theArea;
        theField.Offset(1);
        theField.Width = 2;

        if (theGridPtr->Cells[1][i + 1] == AreaBattleStateStr[0]) {
            DataWrite(theField, 0);
        } else if (theGridPtr->Cells[1][i + 1] == AreaBattleStateStr[1]) {
            DataWrite(theField, 3);
        }
        // xźCh䑤́C_P`W
        theField = theArea;
        theField.Offset(3);
        theField.Width = 2;
        for (int j = 0; j < 10; j++) {
            if (theGridPtr->Cells[2 + j][i + 1] == AreaAffiliationStr[0]) {
                DataWrite(theField, 0);
            } else if (theGridPtr->Cells[2 + j][i + 1] == AreaAffiliationStr[1]) {
                DataWrite(theField, 1);
            } else if (theGridPtr->Cells[2 + j][i + 1] == AreaAffiliationStr[2]) {
                DataWrite(theField, 2);
            } else if (theGridPtr->Cells[2 + j][i + 1] == AreaAffiliationStr[3]) {
                DataWrite(theField, 3);
            }
            theField.Offset(2);
        }

        theArea.Offset(field.Width);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SectionDataWrite(const TField &field)
{
    // P/Q̃f[^
    TComboBox *theCntPtr = (TComboBox *)field.ControlPtr;
 
    if (theCntPtr->ItemIndex == 0) {
        DataWrite(TField(theCntPtr, 0x0011, 3, 1), 1);
        DataWrite(TField(theCntPtr, 0x0010, 1, 1), 0);
        DataWrite(TField(theCntPtr, 0x0010, 0, 1), 0);
    } else if (theCntPtr->ItemIndex == 1) {
        DataWrite(TField(theCntPtr, 0x0011, 3, 1), 0);
        DataWrite(TField(theCntPtr, 0x0010, 1, 1), 1);
        DataWrite(TField(theCntPtr, 0x0010, 0, 1), 0);
    } else if (theCntPtr->ItemIndex == 2) {
        DataWrite(TField(theCntPtr, 0x0011, 3, 1), 0);
        DataWrite(TField(theCntPtr, 0x0010, 1, 1), 1);
        DataWrite(TField(theCntPtr, 0x0010, 0, 1), 1);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SpecialPlanDataWrite(const TField &field)
{
    // ʃṽf[^
    TCheckListBox *theCheckListPtr = (TCheckListBox *)field.ControlPtr;
    TField theField;
    TCellField *theCellFieldPtr;

    for (int i = 0; i < mSpecialPlanList->Count; i++) {
        theCellFieldPtr = (TCellField *)mSpecialPlanList->Items[i];
        theField.Address = theCellFieldPtr->Address;
        theField.Bit = theCellFieldPtr->Bit;
        theField.Width = theCellFieldPtr->Width;

        DataWrite(theField, theCheckListPtr->Checked[theCellFieldPtr->Row]);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DataWrite(const TField &field, unsigned long value)
{
    unsigned long theLongMask;
    char *theChar, *theCharMask;
    theLongMask = 0xFFFFFFFF;
    theChar = (char *)&value;
    theCharMask = (char *)&theLongMask;

    // Kvȃrbg̐؂o
    value = value << (32 - field.Bit - field.Width);
    theLongMask = theLongMask >> (32 - field.Width);
    theLongMask = theLongMask << (32 - field.Bit - field.Width);
    theLongMask = ~theLongMask;

    // fobOmFp
    //AnsiString theMsg;
    //theMsg.printf("value = %08X\nmask  = %08X", value, theLongMask);
    //ShowMessage(theMsg);

    // GfBA̕ύXirbO->gj
    for (int i = 0; i < 4; i++) {
        if (field.Address + i < mSaveDataSize) {
            // fobOmFp
            //theMsg.printf("data = %02X\nmask = %02X\nsave = %02X",
            //               theChar[3 - i], theCharMask[3 - i], mSaveData[add[0] + i]);
            //ShowMessage(theMsg);
            mSaveData[field.Address + i] &= theCharMask[3 - i];
            mSaveData[field.Address + i] |= theChar[3 - i];
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid_1SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
    // ҏWłZ̐ StringGrid1_1`StringGrid3_1
    TStringGrid *theGridPtr = (TStringGrid *)Sender;
    switch (ACol) {
        case 2:
            theGridPtr->Options << goEditing;
            break;
        default:
            theGridPtr->Options >> goEditing;
    }
    CanSelect = true;
    return;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid_2SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
    // ҏWłZ̐ StringGrid1_2`StringGrid3_2
    TStringGrid *theGridPtr = (TStringGrid *)Sender;
    switch (ACol) {
        case 1: case 3: case 4: case 5: case 6: case 7: case 9: case 11: case 12: case 14: case 16: case 17: case 18: case 19:
            theGridPtr->Options << goEditing;
            break;
        default:
            theGridPtr->Options >> goEditing;
    }
    CanSelect = true;
    return;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid4_1SelectCell(TObject *Sender, int ACol,
      int ARow, bool &CanSelect)
{
    // ҏWłZ̐ StringGrid4
    TStringGrid *theGridPtr = (TStringGrid *)Sender;
    switch (ACol) {
        case 1: case 3: case 4: case 6: case 8: case 10: case 11: case 12: case 13:
            theGridPtr->Options << goEditing;
            break;
        default:
            theGridPtr->Options >> goEditing;
    }
    CanSelect = true;
    return;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid5_1SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
    // IłZ̐ StringGrid5_1
    TStringGrid *theGridPtr = (TStringGrid *)Sender;
    switch (ACol) {
        case 2: case 4:
            theGridPtr->Options << goEditing;
            break;
        default:
            theGridPtr->Options >> goEditing;
    }
    CanSelect = true;
    return;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid5_2SelectCell(TObject *Sender,
      int ACol, int ARow, bool &CanSelect)
{
    // IłZ̐ StringGrid5_2
    switch (ACol) {
        case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11:
            CanSelect = true;
            return;
        default:
            CanSelect = false;
            return;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid_2DblClick(TObject *Sender)
{
    // GfB^\
    if (mSaveDataReady) {
        UnitEditForm->Show();
    }

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid_1ContextPopu(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
    // Jv|bvAbvj[̐
    TStringGrid *theGridPtr = (TStringGrid *)Sender;
    TPoint thePoint;
    int theCol, theRow;
    if (mSaveDataReady) {
        // ENbNꂽʒũZ߂
        theGridPtr->MouseToCell(MousePos.x, MousePos.y, theCol, theRow);
        if (theRow > 0 && theCol == 1) {
            // Z̑I
            theGridPtr->Row = theRow;
            theGridPtr->Col = theCol;
            // |bvAbvj[̕\
            thePoint = theGridPtr->ClientOrigin;
            thePoint.x += MousePos.x;
            thePoint.y += MousePos.y;
            PlanPopupMenu->Popup(thePoint.x, thePoint.y);
        }
    }
    Handled = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid_2ContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
    // |bvAbvj[̐
    TStringGrid *theGridPtr = (TStringGrid *)Sender;
    TPoint thePoint;
    int theCol, theRow;
    if (mSaveDataReady) {
        // ENbNꂽʒũZ߂
        theGridPtr->MouseToCell(MousePos.x, MousePos.y, theCol, theRow);
        if (theRow > 0 && theCol == 13) {
            // Z̑I
            theGridPtr->Row = theRow;
            theGridPtr->Col = theCol;
            // |bvAbvj[̕\
            thePoint = theGridPtr->ClientOrigin;
            thePoint.x += MousePos.x;
            thePoint.y += MousePos.y;
            UnitPopupMenu->Popup(thePoint.x, thePoint.y);
        }
    }
    Handled = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::StringGrid5_2ContextPopup(TObject *Sender,
      TPoint &MousePos, bool &Handled)
{
    // GA|bvAbvj[̐
    TStringGrid *theGridPtr = (TStringGrid *)Sender;
    TPoint thePoint;
    int theCol, theRow;
    if (mSaveDataReady) {
        // ENbNꂽʒũZ߂
        theGridPtr->MouseToCell(MousePos.x, MousePos.y, theCol, theRow);

        if (theRow > 0) {
            switch (theCol) {
                case 1:
                    // Z̑I
                    theGridPtr->Row = theRow;
                    theGridPtr->Col = theCol;
                    // |bvAbvj[̕\
                    thePoint = theGridPtr->ClientOrigin;
                    thePoint.x += MousePos.x;
                    thePoint.y += MousePos.y;
                    AreaPopupMenu1->Popup(thePoint.x, thePoint.y);
                    break;
                case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: case 10: case 11:
                    // Z̑I
                    theGridPtr->Row = theRow;
                    theGridPtr->Col = theCol;
                    // |bvAbvj[̕\
                    thePoint = theGridPtr->ClientOrigin;
                    thePoint.x += MousePos.x;
                    thePoint.y += MousePos.y;
                    AreaPopupMenu2->Popup(thePoint.x, thePoint.y);
                    break;
            }
        }
    }
    Handled = true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PlanPopupMenuClick(TObject *Sender)
{
    // |bvAbvj[̌Ăяo𒲂ׂ
    //  Ăяo TStringGrid ̏ꍇ NULL ԂĂ
    //TStringGrid *theGridPtr = (TStringGrid *)PlanPopupMenu->PopupComponent;
    //ShowMessage(theGridPtr->Name);
    // dȂ̂ŁAANeBuɂȂĂ^u݂Ĕf
    TStringGrid *theGridPtr;
    if (PageControl1->ActivePage == TabSheet1 ) {
        theGridPtr = StringGrid1_1;
    } else if (PageControl1->ActivePage == TabSheet2 ) {
        theGridPtr = StringGrid2_1;
    } else if (PageControl1->ActivePage == TabSheet3 ) {
        theGridPtr = StringGrid3_1;
    }

    if ((TComponent *)Sender == PlanPopupMenu1) {
        theGridPtr->Cells[1][theGridPtr->Row] = PlanStateStr[0];
        theGridPtr->Cells[2][theGridPtr->Row] = 0;
    } else if ((TComponent *)Sender == PlanPopupMenu2) {
        theGridPtr->Cells[1][theGridPtr->Row] = PlanStateStr[1];
        theGridPtr->Cells[2][theGridPtr->Row] = 0;
    } else if ((TComponent *)Sender == PlanPopupMenu3) {
        theGridPtr->Cells[1][theGridPtr->Row] = PlanStateStr[2];
        theGridPtr->Cells[2][theGridPtr->Row] = 0;
    } else if ((TComponent *)Sender == PlanPopupMenu4) {
        theGridPtr->Cells[1][theGridPtr->Row] = PlanStateStr[3];
        theGridPtr->Cells[2][theGridPtr->Row] = 1;
    } else if ((TComponent *)Sender == PlanPopupMenu5) {
        theGridPtr->Cells[1][theGridPtr->Row] = PlanStateStr[4];
        theGridPtr->Cells[2][theGridPtr->Row] = 1;
    } else if ((TComponent *)Sender == PlanPopupMenu6) {
        theGridPtr->Cells[1][theGridPtr->Row] = PlanStateStr[5];
        theGridPtr->Cells[2][theGridPtr->Row] = 0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::UnitPopupMenuClick(TObject *Sender)
{
    // ړ|bvAbvj[̏
    TStringGrid *theGridPtr;
    if (PageControl1->ActivePage == TabSheet1 ) {
        theGridPtr = StringGrid1_2;
    } else if (PageControl1->ActivePage == TabSheet2 ) {
        theGridPtr = StringGrid2_2;
    } else if (PageControl1->ActivePage == TabSheet3 ) {
        theGridPtr = StringGrid3_2;
    }

    if ((TComponent *)Sender == UnitPopupMenu1) {
        theGridPtr->Cells[13][theGridPtr->Row] = UnitMoveTypeStr[0];
    } else if ((TComponent *)Sender == UnitPopupMenu2) {
        theGridPtr->Cells[13][theGridPtr->Row] = UnitMoveTypeStr[1];
    } else if ((TComponent *)Sender == UnitPopupMenu3) {
        theGridPtr->Cells[13][theGridPtr->Row] = UnitMoveTypeStr[2];
    } else if ((TComponent *)Sender == UnitPopupMenu4) {
        theGridPtr->Cells[13][theGridPtr->Row] = UnitMoveTypeStr[3];
    } else if ((TComponent *)Sender == UnitPopupMenu5) {
        theGridPtr->Cells[13][theGridPtr->Row] = UnitMoveTypeStr[5];
    }

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AreaPopupMenu1Click(TObject *Sender)
{
    // 퓬|bvAbvj[̏
    TStringGrid *theGridPtr = StringGrid5_2;

    if ((TComponent *)Sender == AreaPopupMenu1_1) {
        theGridPtr->Cells[1][theGridPtr->Row] = AreaBattleStateStr[0];
    } else if ((TComponent *)Sender == AreaPopupMenu1_2) {
        theGridPtr->Cells[1][theGridPtr->Row] = AreaBattleStateStr[1];
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AreaPopupMenu2Click(TObject *Sender)
{
    // xz̓|bvAbvj[̏
    TStringGrid *theGridPtr = StringGrid5_2;

    if ((TComponent *)Sender == AreaPopupMenu2_1) {
        AreaBaseDataSet(theGridPtr->Col, theGridPtr->Row, AreaAffiliationStr[0], theGridPtr);
    } else if ((TComponent *)Sender == AreaPopupMenu2_2) {
        AreaBaseDataSet(theGridPtr->Col, theGridPtr->Row, AreaAffiliationStr[1], theGridPtr);
    } else if ((TComponent *)Sender == AreaPopupMenu2_3) {
        AreaBaseDataSet(theGridPtr->Col, theGridPtr->Row, AreaAffiliationStr[2], theGridPtr);
    } else if ((TComponent *)Sender == AreaPopupMenu2_4) {
        AreaBaseDataSet(theGridPtr->Col, theGridPtr->Row, AreaAffiliationStr[3], theGridPtr);
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AreaBaseDataSet(const int col, const int row,
      const AnsiString &str, TStringGrid *gridPtr)
{
    // _xz͂̕ύX
    int theVal;

    if (col == 2) {
        gridPtr->Cells[col][row] = str;
        gridPtr->Cells[col + 1][row] = str;
        theVal = gridPtr->Cells[12][row].ToInt();
        if (gridPtr->Cells[1][row] == AreaBattleStateStr[0]) {
            for (int i = 0; i < theVal; i++) {
                gridPtr->Cells[col + i + 2][row] = str;
            }
        }
    } else {
        gridPtr->Cells[col][row] = str;
    }
}
//---------------------------------------------------------------------------

bool __fastcall TMainForm::GetSaveDataReady()
{
    return mSaveDataReady;
}
//---------------------------------------------------------------------------

int __fastcall TMainForm::GetUnitEndurance(int UnitNumber)
{
    // ꗗőϋvԂ
    if (0 <= UnitNumber && UnitNumber < mUnitNameList->Count) {
        return StringGrid7_1->Cells[2][UnitNumber + 1].ToIntDef(-1);
    }
    return -1;
}
//---------------------------------------------------------------------------

int __fastcall TMainForm::GetUnitSupply(int UnitNumber)
{
    // ꗗő啨Ԃ
    if (0 <= UnitNumber && UnitNumber < mUnitNameList->Count) {
        return StringGrid7_1->Cells[3][UnitNumber + 1].ToIntDef(-1);
    }
    return -1;
}
//---------------------------------------------------------------------------

int __fastcall TMainForm::GetUnitEmbarkation(int UnitNumber)
{
    // ꗗ瓋ڐԂ
    if (0 <= UnitNumber && UnitNumber < mUnitNameList->Count) {
        return StringGrid7_1->Cells[4][UnitNumber + 1].ToIntDef(-1);
    }
    return -1;
}
//---------------------------------------------------------------------------

